﻿#!/usr/bin/perl
use Switch;
use DBI;
use FileHandle;
use Time::Local;

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - 3600);

$year += 1900;
$mon = sprintf("%02d", $mon + 1);
$mday = sprintf("%02d", $mday);
$sdate = "$year-$mon-$mday";
$startHl = $hour;
if($hour eq 23){
	$endH = 24;
}else{
	$endH = $hour + 1;
}

$packet_size = 4096;

####################################################################
#設定はここから。
####################################################################
#任意の時間を処理する場合、以下を設定
#$sdate = '2010-06-05';
#$startHl = '23';
#$endH = '24';
#
# define.plの場所
require 'c:\OneSegWWW\httpd-doc\define.pl';
#
# segwrapperの場所
use lib 'c:\OneSegWWW\perlrtmp\lib';
#
####################################################################
#設定たぶんここまで。
####################################################################

use segwrapper; 

my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
my $sql = <<END;
select dc_id, dc_name from da_channel order by dc_id
END
my $sth = $dbh->prepare($sql);
my $rv = $sth->execute();
my @channel = ();
while (my $ref = $sth->fetch()) {
	my($dc_id, $dc_name) = @$ref;
	push(@channel, $dc_id);

}
my $sql = <<END;
select
 strftime('%Y%m%d-%H%M%S', e.dv_start_time),
 c.dc_ch
 from
 da_event e inner join da_channel c 
 on
 e.dv_service_id = c.dc_service_id 
 where
 e.dv_start_time >= datetime(?,?) and e.dv_start_time < datetime(?,?) and c.dc_id = ?
 order by
 e.dv_start_time
END
;#

undef $sth;
my $sth = $dbh->prepare($sql);
@objImg = ();
foreach $dc_id (@channel) {
	$rv = $sth->execute($sdate,"$startHl hours", $sdate,"$endH hours", $dc_id);
	while (my $ref = $sth->fetch()) {
		my($dc_date, $dc_ch) = @$ref;
		push(@objImg, "$dc_date,$dc_ch");
	}
}
undef $sth;
$dbh->disconnect();	

foreach $objRimg (@objImg){
	($dc_date, $dc_ch) = split(/\,/, $objRimg);
	$dc_date =~ /[0-9][0-9]([0-9][0-9][0-9][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9][0-9][0-9])/;
	$special = $ThmDir . "\\" . $1;
	$special .="-xxxxxx-";
	$special .= $dc_ch . ".jpg";
	
	#すでにサムネがあったら作らない。
	if(-e $special){
		print "[no action]$special\n";$log="[COM] no action. $special is already maked.";
	}else{
		print "[make]";
		print "$special\n";
 													
		#サムネ生成
 		$dc_date =~ /[0-9][0-9]([0-9][0-9][0-9][0-9][0-9][0-9])-([0-9][0-9])([0-9][0-9])[0-9][0-9]/;
		$stdayl = $1; $h = $2; $m = $3;
		$stiml = "$h$m" . '05'; $etiml = "$h$m" . '45';
		$file = $stdayl . "-" . $stiml . "-" .  $etiml . "-" . $dc_ch;
		$opt = O_RDONLY | O_BINARY;
		eval { $opt |= O_LARGEFILE; };
		if(open(OTS, "> ./dummy.ts")){
			binmode(OTS);
			segwrapper::segopen($handle, $file, $opt);
			while(segwrapper::segread($handle, my $buf, $packet_size)) { print OTS $buf; }
		}
		segwrapper::segclose($handle);
		close(OTS);
		$fiszts = (-s "./dummy.ts");
		if($fiszts > 0){
			open(IN, "$FFMpeg -y -i .\\dummy.ts -vframes 1 -ss 40 -s 107x60 -an -deinterlace $special|");
			while(<IN>){ print;}
			close(IN);
		}else{
			unlink "$special";
		}
		unlink "./dummy.ts";
	}
}
